# This is the location for the files of the repolib sub package
# containg artifacts to be added to the MEAD repository:
%global meaddir %{_javadir}/repository.jboss.com/maven2-brew/org/ovirt/engine/sdk/sdk/%{version}

Name: java-ovirt-engine-sdk4
Version: 4.3.0
Release: 1%{?dist}
Summary: Java SDK for version 4 of the oVirt Engine API
Group: Development/Libraries
License: ASL 2.0
URL: http://ovirt.org/wiki/SDK

# Most of the source code of the SDK is generated automatically, but
# that isn't part of this build process, so in order to update the
# sources of this RPM you need to clone the upstream repository, run the
# generator, and use the generated tarball:
#
# git clone git://gerrit.ovirt.org/ovirt-engine-sdk-java
# cd ovirt-engine-sdk-java
# ./automation/build-artifacts.sh
# cp ./packaging/ovirt-engine-sdk-java-4.0.0.tar.gz ...
Source0: ovirt-engine-sdk-java-%{version}.tar.gz

# This Ant build file is part of the downstream process, for
# environments where Maven isn't available:
Source1: build.xml
# This is tranformation file to make our pom xml independent
# of unnecessary dependecies:
Source2: tranform-pom.xsl

BuildArch: noarch

BuildRequires: ant
BuildRequires: java-1.8.0-openjdk-devel
BuildRequires: jpackage-utils
BuildRequires: libxslt
BuildRequires: mvn(com.sun.xml.txw2:txw2)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.httpcomponents:httpcore)
BuildRequires: mvn(org.codehaus.jackson:jackson-core-asl)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.slf4j:slf4j-api)

Requires: mvn(com.sun.xml.txw2:txw2)
Requires: mvn(org.apache.httpcomponents:httpclient)
Requires: mvn(org.apache.httpcomponents:httpcore)
Requires: mvn(org.codehaus.jackson:jackson-core-asl)
Requires: mvn(org.codehaus.jackson:jackson-mapper-asl)
Requires: mvn(org.slf4j:slf4j-api)

%description
This package contains the Java SDK for version 4 of the oVirt Engine
API.

%package repolib
Summary: %{name} Maven repository

%description repolib
%{name} Maven repository

%prep

# Unpack the source:
%setup -q -n ovirt-engine-sdk-java-%{version}

%build

# Make sure that Java 8 will be used regardless of other installed
# versions:
JAVA_HOME=$(dirname $(rpm -ql java-1.8.0-openjdk-devel | grep '/bin$'))
PATH="${JAVA_HOME}/bin:${PATH}"
export JAVA_HOME PATH

# Replace the version number in the POM file with the version number
# of the RPM followed by the MEAD release number:
sed -i \
  '0,/<version>.*<\/version>/s/<version>.*<\/version>/<version>%{version}<\/version>/' \
  pom.xml

# We need to remove parent element and artifactId of the parent element,
# so we lost dependecy to java-sdk-parent artifactId. Which is not released
# to mead. We also remove test dependencies and build element:
xsltproc -o pom.xml %{SOURCE2} pom.xml

# Copy the Ant build script to the directory containing the source of
# the SDK:
cp %{SOURCE1} build.xml

# Populate the lib directory with symlinks to the required dependencies that
# will be used to create the compiler classpath:
mkdir lib
while read jar
do
  ln -s %{_javadir}/${jar}.jar lib
done <<.
httpcomponents/httpclient
httpcomponents/httpcore
jackson/jackson-core-asl
jackson/jackson-mapper-asl
slf4j/api
txw2
.

# Perform the build using Ant:
java -jar %{_javadir}/ant-launcher.jar -f build.xml

%install

# Install the files for the main package:
install -d -m 755 %{buildroot}%{_javadir}/%{name}
install -pm 644 target/sdk.jar %{buildroot}%{_javadir}/%{name}/sdk.jar

# Install the POM file:
install -d -m 755 %{buildroot}/%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}/%{_mavenpomdir}/JPP.%{name}-sdk.pom
%add_maven_depmap JPP.%{name}-sdk.pom %{name}/sdk.jar

# Install the files for the repolib package:
mkdir -p %{buildroot}%{meaddir}
cp target/sdk.jar %{buildroot}%{meaddir}/sdk-%{version}.jar
cp pom.xml %{buildroot}%{meaddir}/sdk-%{version}.pom

%files
%doc README.adoc
%license LICENSE.txt
%{_javadir}/%{name}
%{_mavendepmapfragdir}/*
%{_mavenpomdir}/*

%files repolib
%{_javadir}/repository.jboss.com

%changelog
* Wed Jan 16 2019 Ondra Machacek <omachace@redhat.com> - 4.3.0-1
- Update to upstream 4.3.0.
- Update to model 4.3.21 and metamodel 1.3.0.

* Wed Jan 14 2018 Ondra Machacek <omachace@redhat.com> - 4.2.1-1
- Update to model 4.2.29 and metamodel 1.2.17.
- Support multiple output parameters.

* Mon Dec 4 2017 Ondra Machacek <omachace@redhat.com> - 4.2.0-1
- Update to upstream 4.2.0.
- Update to model 4.2.25.
- Update to metamodel 1.2.13.
- Add support for method extensions.
- Fix service inheritance rhbz#1496954.
- Fix XML tag for list of enums rhbz#1512850.

* Wed Sep 27 2017 Ondra Machacek <omachace@redhat.com> - 4.2.0-0.1.alpha2
- Update to model 4.2.19.

* Mon Jun 19 2017 Ondra Machacek <omachace@redhat.com> - 4.2.0-0.1.alpha1
- Update to model 4.2.8 and metamodel 1.2.3.

* Thu Mar 02 2017 Ondra Machacek <omachace@redhat.com> - 4.1.1-1
- Update to model 4.1.31.
- Add `auto_storage_select` attribute to the `VmPool` type.
- Add IPv6 details to the `NicConfiguration` type.
- Add NFS 4.2 support.
- Add new `lease` attribute to virtual machines and templates.
- Add `execution_host` link to the `Step` type.
- Add `initial_size` attribute to the `Disk` type.
- Add `succeeded` parameter to the operation that end an external job.
- Move `vnic_profile_mappings` and `reassign_bad_macs` from
  the `import` operation to the `register` operation
  https://bugzilla.redhat.com/1425731[#1425731].

* Tue Jan 31 2017 Ondra Machacek <omachace@redhat.com> - 4.1.0-1
- Update to model 4.1.29.
- Improved documentation.
- Add new lease attribute to virtual machines and templates.

* Wed Jan 18 2017 Ondra Machacek <omachace@redhat.com> - 4.1.0-0.1.alpha1
- Update to model 4.1.27 and metamodel 1.1.10.
- Fix reading of XML attributes of enum types #1408839.
- Enable compression by default #1370485.

* Tue Sep 20 2016 Ondra Machacek <omachace@redhat.com> - 4.0.2-1
- Update to model 4.0.33 and metamodel 4.0.18
- Add the `custom_scheduling_policy_properties` attribute to the `Cluster` type
- Add services and types to support transfer of images
- Remove the `add` and `remove` operations of virtual machine CDROMs
- Use pooling http client
- Fix the type of the `usages` attribute of the `Network` type

* Tue Sep 13 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.1-2
- Install the POM file #1375667.

* Mon Sep 05 2016 Ondra Machacek <omachace@redhat.com> - 4.0.1-1
- Update jackson dependencies versions to latest version
- Generate RPM Maven dependencies
- Avoid of reading fault response in case response body is empty
- Don't return null from send method in case of failure
- Fix tag names of action parameters

* Wed Aug 31 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-2
- Fix mead pom file to be independet of it's dependencies

* Mon Aug 29 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-1
- Add missing required packages to spec files

* Mon Aug 22 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-0.15.alpha15
- Update to upstream 4.0.15.alpha15.
- Use POST method
- Name plular element tag same as the member
- Send query parameters with Add/Update actions
- Update to model 4.0.32 and metamodel 1.0.17
- Add option to not revoke token when closing connection
- Support both httpclient versions in built jar
- Add support to pass SSO token to SDK connection
- Support /v4 meadrel in API URL

* Tue Jul 19 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-0.13.alpha13
- Update to upstream 4.0.13.alpha13.
- Update to model 4.0.28.
- Added `switch_type` attribute to `Host` type.
- Add `permits` to the cluster level type.
- Add the `current` parameter to the virtual machine graphics consoles service.
- Fix the name of the output parameter of the method to list affinity
  groups, should be `groups` instead of `list`.

* Wed Apr 13 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.0
- Initial packaging.
